<template lang="pug">
.subida( :class="[estado,{expandido}]", @click="alternar")
	#ninguno
	.imagen
		figure.previo( v-if="imagen.length" ): img( :src="imagen", ref="miniatura", alt="previo")
		IconoFichero.icono( v-else, :ext="extension" )
		.cambiar
			input#foto( type="file", ref="foto", @change="fotoChange" )
			span Cambiar Imagen

	h2.nombre {{ nombre | capitalizar }}.{{ extension }}
	label.estado {{ estado | capitalizar }}
	.progreso
		.barra: .indicador( :style = "{ width: progreso + '%' }" )
	.acciones
		//-p {{ factor }}
		//-button.cancelar( type = 'button', v-if = "progreso < 100", @click="cancelar" ) Cancelar
		button.guardar( type = 'button', v-if = "estado == 'completado'", @click="guardar" ) Guardar
		button.reintentar( type = 'button', v-if = "estado == 'error'" ) Reintentar
		button.borrar( type = 'button', v-if = "estado != 'error'", @click="borrar" ) Cancelar
		button.alternar( type="button", @click.stop="alternar" )

	.campos
		label(
			for = "nombre",
			) Nombre
		.campo.descripcion(
			v-model = "nombre",
			name = "nombre",
			tipo = "text",
			placeholder  = "nombre del archivo",)
			input(
				v-model = "nombre",
				type = "text",
				name = "descripcion"
				placeholder = "Descripción"
				)
		label(
			for = "descripcion",
			) Descripcion
		.campo.descripcion(
			v-model = "descripcion",
			name = "descripcion",
			tipo = "text",
			placeholder  = "Descripcion del archivo",)
			input(
				v-model = "descripcion",
				type = "text",
				name = "descripcion"
				placeholder = "Descripción"
				)

		label(
			for="categoria",
			) Categoria
		.campo.categoria
			//-SelectorCategorias
			select( name="categoria", v-model="categoria", id="categoria" )
				option( disabled, selected, value="0" ) Elije una categoria
				option( v-for="cat in categorias", :value="cat.id" ) {{ cat.nombre }}

			select( name="subcategoria", v-model="subcategoria", id="subcategoria" )
				option( disabled, selected, value="0" ) Elije una subcategoria
				option( v-for="scat in subcategorias", :value="scat.id" ) {{ scat.nombre }}

			//-.opcion( v-for="item in categorias", :key="item.id" )
					input( :id="'c'+item.id", type="radio", name="categoria", :value="item.id", v-model="categoria" )
					label( :for="'c'+item.id" ): span {{ item.nombre }}
			//-treeselect( v-model="categoria", :multiple="false" :options="categorias")

		label(
			for="etiquetas",
			) Etiquetas
		.campo.etiquetas
			tags-input(element-id="etiquetas",
				placeholder="Agrega una etiqueta"
				:add-tags-on-comma="true"
				v-model="etiquetasSelecionadas",
				:existing-tags="etiquetas",
				:typeahead="true"
				@tags-updated="etiquetasActualizadas")


	//-pre.
		{{ etiquetasSelecionadas }}
		{{ etiquetasIds }}
		{{ etiquetasNuevas }}

</template>

<script>
	import IconoFichero from "@/components/IconoFichero";
	import ItemCampo from "@/components/ItemCampo";
	import SelectorCategorias from "@/components/SelectorCategorias";
	import VoerroTagsInput from "@voerro/vue-tagsinput";

	import { config, archivos } from "@/api";
	import { mapState, mapGetters } from "vuex";
	import crc32 from "crc-32";

	const plupload = require("plupload");
	const opcionesPlupload = {
		browse_button: "ninguno",
		runtimes: 'html5,html4',
		url: config.accion("plupload"),
		multipart_params: {
			usuario: 1,
		},


	}

	export default {
		name: "Subida",
		components: {
			IconoFichero,
			ItemCampo,
			SelectorCategorias,
			VoerroTagsInput: "tags-input"
		},
		data() {
			return {
				activo: false,
				contenido: "",
				largo: 0,
				subida: 0,
				total: -1,
				extension: "",
				nombre: "",
				estado: "subiendo",
				categoria: 0,
				descripcion: "",
				expandido: true,
				etiquetasSelecionadas: [],
				etiquetasIds: [],
				etiquetasNuevas: [],
				factor: 7.5e5,
				imagen: "",
				subcategoria: 0,
				subcategorias: [],
				progreso: 0,
				plupload: null
			};
		},
		watch: {
			categoria(nuevo) {
				let nueva = this.categorias.find(e => e.id == nuevo);

				this.subcategorias = nueva.descendientes;
			}
		},
		computed: {
			// progreso() {
			// 	return (this.subida / this.total) * 100;
			// },
			...mapState([
				"carpeta",
				"usuario",
				"categorias",
				"etiquetas",
				"disco",
				"taxonomia"
			]),
			...mapState({
				categoriaActual: "categoria"
			}),
			...mapGetters(["esImagen"])
		},
		props: {
			archivo: {
				type: File,
				required: true
			},
			idu: {
				type: String,
				required: true
			}
		},
		created() {
			//console.log( "Crs", this.archivo );
			var reader = new FileReader();
			reader.onload = this.fileReaderLoad;
			reader.readAsBinaryString(this.archivo);

			this.$nextTick(function() {
				opcionesPlupload.multipart_params = {
					id: this.idu,
					usuario: 1,
					nombre: this.nombre,
					ext: this.extension,
				};

				console.debug(opcionesPlupload);

				this.plupload = new plupload.Uploader(opcionesPlupload);
				this.plupload.bind("PostInit", function(uploader){
					console.debug(this.archivo, this.nombre);

					this.plupload.addFile(this.archivo, this.nombre);
					this.plupload.start();
				}, this);

				this.plupload.bind("Error", function(up, error){
					console.error(error);
				});

				this.plupload.bind("FilesAdded", function(up, files ){
					console.debug(files);
				});

				this.plupload.bind("UploadProgress", function(up, file){
					this.progreso = file.percent;
				}, this);
				this.plupload.bind("FileUploaded", function(up, file, result){
					this.estado = "completado";
				}, this);
				this.plupload.bind("Error", function(up, err){
					this.estado = "error";
				}, this);

				this.plupload.init();

				this.$nextTick(function() {
					console.debug(this.plupload);
				});
			});

			const p = this.archivo.name.lastIndexOf(".");
			this.extension = this.archivo.name.split(".").pop();
			this.nombre = this.archivo.name.substring(0, p);

			if (this.taxonomia == "categoria") {
				//this.categoriaActual.
				if (this.categoriaActual.contenedora == "1") {
					this.categoria = this.categoriaActual.id;
				} else {
					this.categoria = this.categoriaActual.contenedora;
					this.subcategoria = this.categoriaActual.id;
				}
			}

		},
		mounted(){
			this.activo = true;
			console.info('Nueva Subida', this.archivo.name);
		},
		beforeDestroy(){
			this.plupload.destroy();
		},
		methods: {
			fileReaderLoad(evt) {
				let fr = evt.currentTarget;
				//console.log( "R", fr.result);
				//this.contenido = [];

				this.contenido = fr.result;
				this.total = Math.ceil(this.contenido.length / this.factor);
				this.subida = 0;
				this.largo = this.contenido.length;
				//this.subirContenido();
				//this.$worker.run(this.subirContenido);

				if (this.esImagen(this.extension)) {
					var urlImage = URL.createObjectURL(this.archivo);
					this.redimensionar(urlImage).then(img => (this.imagen = img));
					// var imagen = new FileReader();
					// imagen.onload = () => {
					// 	this.redimensionar( imagen.result )
					// 		.then( img => this.imagen = img )
					// };
					// imagen.readAsDataURL( this.archivo );
				}

				console.debug( "Archivo cargado", {
					tamaño: this.largo,
					partes: this.total,

				});

			},

			fotoChange() {
				if (this.$refs.foto.files.length) {
					var imagen = new FileReader();
					imagen.onload = () => {
						this.redimensionar(imagen.result).then(
							img => (this.imagen = img)
						);
					};
					imagen.readAsDataURL(this.$refs.foto.files[0]);
					//imagen.readAsDataURL( this.archivo );
				}
			},

			redimensionar(dataurl, tamaño = 640, calidad = 0.9) {
				const D = document;
				return new Promise((resolver, rechazar) => {
					const img = D.createElement("img");
					const canvas = D.createElement("canvas");
					const ctx = canvas.getContext("2d");

					//console.log( "retrollamada", retrollamada );
					img.src = dataurl;
					img.onload = function() {
						const proporcion = img.naturalHeight / img.naturalWidth;

						const medida = Math.min(
							Math.max(img.naturalWidth, img.naturalHeight),
							tamaño
						);

						if (proporcion < 1) {
							canvas.width = medida;
							canvas.height = Math.round(medida * proporcion);
						} else {
							canvas.width = Math.round(medida / proporcion);
							canvas.height = medida;
						}
						ctx.drawImage(img, 0, 0, canvas.width, canvas.height);

						resolver(canvas.toDataURL("image/jpeg", calidad));
					};
				});
			},

			subirContenido() {
				const parte = this.contenido.substring(0, this.factor);
				const contenido = btoa(parte)
				//const crc = crc32.str(contenido);
				//console.debug(btoa(parte));

				if(!this.activo){
					return;
				}

				console.debug( "subiendo fragmento", {
					número: this.subida + 1,
					total: this.total,
					largo: parte.length,
				});

				const envio = {
					id: this.idu,
					usuario: 1,
					nombre: this.nombre,
					ext: this.extension,
					parte: this.subida + 1,
					total: this.total,
					contenido: contenido,
					//crc: crc,
					largo: parte.length,
				};
				//constconsole.debug(crc);

				archivos.subir(envio).then(
					r => {
						//console.debug(crc, r.crc, r.crc == crc)


						if ( r.ok ) {
							console.info("Subido OK");
						//console.log( "R", r );
							if (this.subida < this.total) {
								this.subida = r.subida;
								this.contenido = this.contenido.substring(this.factor);
								this.subirContenido();
							} else {
								this.estado = "completado";
								console.info("Subida completada");
							}
						}else{
							this.$nextTick(function() {
								if (this.activo ) {
									console.warn("Resubiendo fragmento");
									this.subirContenido();
								}
							});
						}
						//this.$worker.run(this.subirContenido);
					},
					error => {
						//console.log( error );
						console.error( error);
						this.$nextTick(function() {
							console.warn("Reintentando subida");
							this.subirContenido();

						});
					}
				);
			},

			borrar() {
				let rpta = confirm("¿Desea cancelar la subida de este archivo?");
				if (rpta) {
					this.activo = false;
					console.info('Subida cancelada');
					this.$emit("terminada", this.idu);
					this.plupload.stop();
				}
			},
			guardar() {
				//console.log( "guardar" );
				if (this.categoria == 0) {
					alert(
						"Por favor elije una categoria para el archivo: " +
							this.nombre
					);
					return;
				}

				this.etiquetasIds = this.etiquetasSelecionadas.filter(item =>
					parseInt(item)
				);
				this.etiquetasNuevas = this.etiquetasSelecionadas.filter(
					item => !parseInt(item)
				);

				let carpeta;

				if (this.taxonomia == "carpeta") {
					carpeta = this.carpeta.id;
				} else {
					carpeta = this.disco.id;
				}

				archivos
					.guardar({
						id: this.idu,
						usuario: 1,
						nombre: this.nombre,
						ext: this.extension,
						carpeta: carpeta,
						categoria: this.categoria,
						subcategoria: this.subcategoria,
						descripcion: this.descripcion,
						//largo: this.largo,
						etiquetas: {
							ids: this.etiquetasIds,
							nuevas: this.etiquetasNuevas
						},
						imagen: this.imagen
					})
					.then(
						r => {

							if(r.ok){
								console.info("Archivo guardado");
								this.activo = false;
								console.info("guardado", this.idu);
								this.$emit("terminada", this.idu);
							}
							else{
								alert(r.mensajes[0]);
								console.error(r.mensajes);
							}
						},
						error => {
							this.estado = "error";
							console.error(error);
						}
					);
				//this.$emit( 'guadado', this.idu );
			},
			cancelar() {
				this.activo = false;
				this.$emit("terminada", this.idu);
			},
			alternar(evt) {
				if (evt.currentTarget.classList.contains("alternar")) {
					this.expandido = !this.expandido;
				} else {
					this.expandido = true;
				}
			},
			etiquetasActualizadas() {
				console.debug(
					"etiquetasActualizadas",
					this.etiquetasSelecionadas.length
				);
				this.etiquetasIds = this.etiquetasSelecionadas.filter(item =>
					parseInt(item)
				);
				this.etiquetasNuevas = this.etiquetasSelecionadas.filter(
					item => !parseInt(item)
				);
			}
		}
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	.subida
		background-color blanco
		padding .2rem
		border-radius .2rem
		display grid
		grid-template-areas "imagen nombre estado progreso acciones"
		grid-gap 0 .3rem
		align-items center
		justify-items stretch // center
		justify-content stretch // center
		align-content center
		grid-template-rows repeat( 3, none )
		grid-template-columns 16px minmax( 120px, 20% ) max-content 1fr max-content
		// grid-template-columns minmax( 32px, 10% ) minmax( 120px, 20% ) 1fr
		cursor pointer

		&.expandido
			grid-gap 1rem
			grid-template-areas "imagen nombre estado progreso acciones" "imagen nombre campos campos campos"
			grid-template-columns max-content minmax( 120px, 20% ) max-content 1fr max-content
			padding 1rem
			border-radius .5rem
			cursor default

		> *
			// -outline 1px solid red

		.expandido &.subiendo,
		.expandido &.completado
			// grid-template-areas "icono nombre estado progreso acciones" \
			// "imagen nombre campos campos campos"

		&.completado,
		&.cancelado
			background-color darken( blanco, 5% )

		label
			color gris
			font-weight 500
			font-size calcRem( 10 )

		&.expandido
			label
				color gris
				font-weight 500
				font-size calcRem( 12 )

	.imagen
		grid-area imagen
		display flex
		position relative
		flex-direction column
		align-items stretch

		caja = 165px

		.expandido &
			min-width 64px

			.previo
				gris1 = lighten( azul, 85% )
				gris2 = lighten( azul, 95% )

				background-color gris1
				background-image linear-gradient( 45deg, gris2 25%, transparent 25%, transparent 75%, gris2 75%, gris2 ), linear-gradient( 45deg, gris2 25%, transparent 25%, transparent 75%, gris2 75%, gris2 )
				background-size 33px 33px
				background-position 8px 8px, 24px 24px
				background-repeat repeat
				margin 0
				padding 0
				display grid
				justify-content stretch
				align-content stretch
				justify-items center
				align-items stretch
				position relative

			img
				object-fit cover
				margin 0
				padding 0
				width caja
				height caja

			.icono
				width caja
				height caja

		.cambiar
			background-color tint( azul, 40% )
			display none
			width auto
			padding .5em
			font-size calcRem( 14 )
			color blanco
			position relative
			cursor pointer
			opacity 1
			cursor pointer

			.expandido &
				display block

			&:hover
				opacity 1
				background-color tint( azul, 20% )

			input
				absolute top left right bottom
				width 100%
				height 100%
				opacity 0
				cursor pointer

			span
				display block
				text-align center

	.nombre
		grid-area nombre
		color lighten( negro, 40% )
		font-size calcRem( 12 )

		.expandido &
			font-size calcRem( 16 )

	.estado
		grid-area estado
		font-size calcRem( 14 )

		.subiendo &,
		.completado &
			color azul

		.error &
			color rojo

	.progreso
		grid-area progreso

		.barra,
		.indicador
			display block
			height 18px
			border-radius 4px
			background-color tint( azul, 80% )
			transition all 350ms linear

		.indicador
			background-color tint( azul, 60% )

			.subiendo &
				background-image repeating-linear-gradient(
					45deg,
					tint( azul, 20% ),
					tint( azul, 20% ) 6px,
					tint( azul, 55% ) 6px,
					tint( azul, 55% ) 12px
				 )
				background-size 200%
				animation barras 5s linear infinite

			.completado &
				background-color tint( azul, 40% )
				min-width 100%

			.error &
				background-color tint( rojo, 40% )
				min-width 100%

			.cancelado &
				background-color gris
				min-width 100%

	@keyframes barras
		from
			background-position 90% 100%

	.acciones
		grid-area acciones
		display grid
		grid-gap .5rem
		grid-auto-flow column
		grid-auto-columns auto

		button
			background-color gris
			border-radius 3rem
			font-size calcRem( 10 )
			font-weight 500
			padding .25rem .5rem
			color blanco

			.expandido &
				border-radius 3rem
				font-size calcRem( 12 )
				font-weight 500
				padding .5rem 1rem

			&.cancelar
				background-color tint( azul, 30% )

			&.guardar
				background-color verde
				display none

				.expandido &
					display block

			&.reintentar
				background-color tint( rojo, 20% )

			&.borrar
				background-color darken( gris, 50% )
				display none

				.expandido &
					display block

			&.alternar
				padding .2rem
				align-self start
				width 1.5em
				height @width
				background-color transparente

				&:hover
					background-color transparente

				&::before
					content ""
					width 0
					height 0
					border 6px solid transparente
					border-top 6px solid azul
					border-bottom none
					display block
					transform rotate( 90deg )
					transition transform 150ms linear

					.expandido > &
						transform rotate( 0 )

	.campo
		flex 4 0 auto
		font-size calcRem( 12 )
		display flex
		align-items stretch
		min-width 100px
		color gris

		>>> input,
		>>> select
			display block
			padding 1em
			border none
			outline none
			width 100%
			color inherit
			font-size inherit
			line-height 1
			background-color darken( blanco, 5% )

			.completado &
				background-color blanco

		>>> select
			padding-top .9em
			padding-bottom .9em

		.opcion
			flex 0 1 auto
			color blanco
			border-radius 2rem
			margin 0
			padding .5em
			display flex
			align-items center

			input
				display none

				&:checked
					& + label
						&::before
							background-color tint( azul, 30% )

			label
				line-height 1
				cursor pointer
				display flex

				&::before
					flex 0 0 1em
					content ""
					width 1em
					height 1em
					display inline-block
					vertical-align baseline
					background-color blanco
					margin 0 .5em -.15em 0
					border-radius 1em
					box-sizing border-box
					border .25em solid tint( azul, 70% )
					transition all 150ms

			span
				flex 0 1 auto
				white-space nowrap

	.campos
		display none
		grid-area campos

		.expandido &
			display grid
			grid-gap .5rem
			align-items center
			align-content center
			grid-template-columns max-content 1fr

		.label
			grid-column 1

		.campo
			grid-column 2

	.categoria
		flex-wrap wrap

		> select + select
			margin-top .5rem

	.etiquetas
		display flex
		background-color transparente

		> div
			flex-grow 1

		>>> .tags-input
			display flex
			border none

			.tags-input-remove
				cursor pointer
				position relative
				display inline-block
				width .5rem
				height .5rem
				overflow hidden

			.tags-input-remove:before,
			.tags-input-remove:after
				content ""
				position absolute
				width 100%
				top 50%
				left 0
				background-color tint( azul, 50% )
				height 2px
				margin-top -1px

			.tags-input-remove:before
				transform rotate( 45deg )

			.tags-input-remove:after
				transform rotate( -45deg )

			.tags-input input:focus
				outline none

			.tags-input input[type="text"]
				color #495057

			.badge-light
				color darken( gris, 30% )
				background-color tint( azul, 90% )

			.badge-light[href]:focus,
			.badge-light[href]:hover
				color darken( gris, 30% )
				text-decoration none
				background-color tint( azul, 80% )

		>>> .badge
			display inline-block
			padding .25em .4em
			font-size calcRem( 10 )
			font-weight 500
			line-height 1
			text-align center
			white-space nowrap
			vertical-align baseline
			border-radius .25rem

			.badge:empty
				display none

			.badge-pill
				padding-right .6em
				padding-left .6em
				border-radius 10rem

		>>> .typeahead
			margin-top .2rem
			background-color tint( azul, 80% )
			padding .2rem

			.badge-primary
				color #fff
				background-color tint( azul, 20% )

			.badge-primary[href]:focus,
			.badge-primary[href]:hover
				color #fff
				text-decoration none
				background-color tint( azul, 10% )

			.badge-dark
				color #fff
				background-color darken( gris, 10% )

			.badge-dark[href]:focus,
			.badge-dark[href]:hover
				color #fff
				text-decoration none
				background-color darken( gris, 30% )
</style>
